'DatesToRemember 1.1 - by uziq - August 3 2003
'uziq@hotmail.com or samurize@swbell.net
'http://www.geocities.com/samurize@swbell.net/samurize.html
'For use with the DatesToRemember.ini config in Samurize
'Use Samurize 0.85b or newer

'== USER EDITABLE VARIABLES ==========================================================================================================
  WeekNumbers		= 0		'whether or not to display week numbers.	0 = no week numbers / 1 = show week numbers
  LookAhead		= 1		'how many months ahead you want to fetch reminders from.
  DelCommand		= "DEL"	'command to delete reminders.	"DEL" is default.
  ReminderPrefix	= 0		'determines the order of the reminder prefix.  0 = Month-Day / 1 = Day-Month	ex: "Jul 25" or "25 Jul"
  TodayPrefix		= "Today"	'If TodayPrefix="" then today's reminder will look like "(Jul 25) - reminder".  Otherwise, it'll look like "Today - reminder"
  Hyphen		= chr(183)	'this separates the reminder date from the reminder.  ex: "Jul 25 - Reminder"	chr(183) is a dot.
  Indention		= 5		'If Indention > 0, reoccurrences of a date will be replaced by the number of spaces you specify.  5 is default.
					'this only applies for days that have more than one reminder.
					'ex:	Indention = 0			Indention = 7
					'	Jul 25 - reminder#1		Jul 25 - reminder#1
					'	Jul 25 - reminder#2			- reminder#2
					'	Jul 25 - reminder#3			- reminder#3
'=====================================================================================================================================


'=====================================================================================================================================
'== DON'T EDIT BEYOND THIS POINT =====================================================================================================
Dim Square(42)
Dim ReminderDate(31)
Dim Separator(100)
Public ThisYear, LastMonth, ThisMonth, NextMonth
Set FSO = CreateObject("Scripting.FileSystemObject")
SamurizeDir = CreateObject("WScript.Shell").RegRead("HKEY_CURRENT_USER\Software\Serious Samurize\General\DirPath")
Path 		= SamurizeDir & "Scripts"
Root			= Path & "\DatesToRemember\DatesToRemember"
LastMonthFile		= Root & "LastMonth.txt"
ThisMonthFile		= Root & "ThisMonth.txt"
ThisYearFile		= Root & "ThisYear.txt"
NextMonthFile		= Root & "NextMonth.txt"
Days1File		= Root & "Days1.txt"
Days2File		= Root & "Days2.txt"
Reminders1File	= Root & "Reminders1.txt"
Reminders2File	= Root & "Reminders2.txt"
ReminderMessagesFile = Root & "ReminderMessages.txt"
Today1File		= Root & "Today1.txt"
Today2File		= Root & "Today2.txt"
Weekday1File		= Root & "Weekday1.txt"
Weekday2File		= Root & "Weekday2.txt"
Weekday3File		= Root & "Weekday3.txt"
Weekday4File		= Root & "Weekday4.txt"
Weekday5File		= Root & "Weekday5.txt"
Weekday6File		= Root & "Weekday6.txt"
Weekday7File		= Root & "Weekday7.txt"
WeekNumbersFile	= Root & "WeekNumbers.txt"
Blank 			= "                      %b                      %b                      %b                      %b                      %b                      %b                      "

If FSO.FolderExists(Path & "\DatesToRemember") 	= 0 Then FSO.CreateFolder(Path & "\DatesToRemember")
If FSO.FileExists(LastMonthFile)			= 0 Then FSO.CreateTextFile(LastMonthFile, 1).Write(MonthName(Month(Now)-1,1))
If FSO.FileExists(ThisMonthFile)			= 0 Then FSO.CreateTextFile(ThisMonthFile, 1).Write(MonthName(Month(Now)+0,0))
If FSO.FileExists(NextMonthFile)			= 0 Then FSO.CreateTextFile(NextMonthFile, 1).Write(MonthName(Month(Now)+1,1))
If FSO.FileExists(ThisYearFile)			= 0 Then FSO.CreateTextFile(ThisYearFile, 1).Write(Year(Now))
If FSO.FileExists(Weekday1File)			= 0 Then FSO.CreateTextFile(Weekday1File, 1).Write(WeekdayName(1, 1, 0))
If FSO.FileExists(Weekday2File)			= 0 Then FSO.CreateTextFile(Weekday2File, 1).Write(WeekdayName(2, 1, 0))
If FSO.FileExists(Weekday3File)			= 0 Then FSO.CreateTextFile(Weekday3File, 1).Write(WeekdayName(3, 1, 0))
If FSO.FileExists(Weekday4File)			= 0 Then FSO.CreateTextFile(Weekday4File, 1).Write(WeekdayName(4, 1, 0))
If FSO.FileExists(Weekday5File)			= 0 Then FSO.CreateTextFile(Weekday5File, 1).Write(WeekdayName(5, 1, 0))
If FSO.FileExists(Weekday6File)			= 0 Then FSO.CreateTextFile(Weekday6File, 1).Write(WeekdayName(6, 1, 0))
If FSO.FileExists(Weekday7File)			= 0 Then FSO.CreateTextFile(Weekday7File, 1).Write(WeekdayName(7, 1, 0))

LastMonth	= FSO.OpenTextFile(LastMonthFile, 1).Readline 
ThisMonth	= FSO.OpenTextFile(ThisMonthFile, 1).Readline 
NextMonth	= FSO.OpenTextFile(NextMonthFile, 1).Readline 
ThisYear	= FSO.OpenTextFile(ThisYearFile, 1).Readline 

CP = Wscript.arguments.Item(0)	'Current Position of where someone clicked (the numbers are decided in the config ini)
If CP = 43 Then ChangeMonth(-1)	'go back a month
If CP = 44 Then ChangeMonth(0)	'reload current month
If CP = 45 Then ChangeMonth(1)	'go forward a month
'If CP = 50 Then refresh 

CurrentYearPath 		= Path & "\DatesToRemember\" & ThisYear & "\"
CurrentMonthPath 		= CurrentYearPath & ThisMonth & "\"
CurrentDays1File 		= CurrentMonthPath & "Days1.txt"
CurrentDays2File 		= CurrentMonthPath & "Days2.txt"
CurrentReminders1File 	= CurrentMonthPath & "Reminders1.txt"
CurrentReminders2File 	= CurrentMonthPath & "Reminders2.txt"
CurrentWeekNumbersFile	= CurrentMonthPath & "WeekNumbers.txt"

If FSO.FolderExists(CurrentYearPath) 	= 0 Then FSO.CreateFolder(CurrentYearPath)
If FSO.FolderExists(CurrentMonthPath) 	= 0 Then CreateMonth
CurrentDays1 			= FSO.OpenTextFile(CurrentDays1File, 1).Readline
CurrentDays2 			= FSO.OpenTextFile(CurrentDays2File, 1).Readline
CurrentReminders1 		= FSO.OpenTextFile(CurrentReminders1File, 1).Readline
CurrentReminders2 		= FSO.OpenTextFile(CurrentReminders2File, 1).Readline
If WeekNumbers Then CurrentWeekNumbers = FSO.OpenTextFile(CurrentWeekNumbersFile, 1).Readline

FSO.CreateTextFile(Days1File, 1).Write(CurrentDays1)
FSO.CreateTextFile(Days2File, 1).Write(CurrentDays2)
FSO.CreateTextFile(Reminders1File, 1).Write(CurrentReminders1)
FSO.CreateTextFile(Reminders2File, 1).Write(CurrentReminders2)
FSO.CreateTextFile(WeekNumbersFile, 1).Write(CurrentWeekNumbers)

If MonthName(Month(Now)) = ThisMonth And Year(Now) = ThisYear Then HighlightToday	'Highlight today's date
If MonthName(Month(Now)) <> ThisMonth Then						'Un-highlight today's date
 FSO.CreateTextFile(Today1File, 1).Write(Blank)
 FSO.CreateTextFile(Today2File, 1).Write(Blank)
End If

If CP < 43 Or CP = 99 Then CreateReminder		'enter a reminder
ExtractReminders

'===================================================================================================================================
'==== FUNCTIONS ====================================================================================================================
'===================================================================================================================================

Private Function CreateMonth()
  DateString = ThisMonth & "/1/" & ThisYear
  FirstDayOfMonth = DatePart("w", DateString, 0)
  week = 8 - FirstDayOfMonth

For days = 2 - FirstDayOfMonth To 42
  If days > 0 And days < 10 Then
    String1 = String1 & "  " & days
    addweeknumber=1
  Else
    String1 = String1 & "   "
  End If

  If days > 9 Then
    DateString = DateSerial(ThisYear, Month(DateSerial(ThisYear,Month("2000/" & ThisMonth & "/1"),1)), days)
    If Month(DateString) = Month(DateSerial(ThisYear,Month("2000/" & ThisMonth & "/1"),1)) Then
     String2 = String2 & " " & days
     addweeknumber=1
    Else
     String2 = String2 & "   "
    End If
  Else
    String2 = String2 & "   "
  End If

  If days = week Then
    String1 = String1 & " %b"
    String2 = String2 & " %b"
    week=week+7
    If addweeknumber Then WeekNumber = WeekNumber & DatePart("ww", DateSerial(ThisYear, Month(DateSerial(ThisYear,Month("2000/" & ThisMonth & "/1"),1)), days-1), 0) & "%b"
    addweeknumber=0
  End If
Next

FSO.CreateFolder(CurrentMonthPath)
FSO.CreateTextFile(Days1File, 1).Write(String1)
FSO.CreateTextFile(Days2File, 1).Write(String2)
FSO.CreateTextFile(CurrentDays1File, 1).Write(String1)
FSO.CreateTextFile(CurrentDays2File, 1).Write(String2)
FSO.CreateTextFile(CurrentReminders1File, 1).Write(Blank)
FSO.CreateTextFile(CurrentReminders2File, 1).Write(Blank)
FSO.CreateTextFile(CurrentWeekNumbersFile, 1).Write(WeekNumber)
End Function

'===================================================================================================================================

Private Function HighlightToday()

For x = 1 To 42
 If Len(Day(Now)) = 1 And Mid(CurrentDays1, FilePosition(x)+1, 1) <> " " Then
   If Day(Now) = CInt(Mid(CurrentDays1, FilePosition(x)+1, 1)) Then
     Today1 = Mid(Blank, 1, FilePosition(x)-1) & "(  )" & Mid(Blank, FilePosition(x)+2, 168)
     Today2 = Blank
   End If
 End If
 If Len(Day(Now)) = 2 And Mid(CurrentDays2, FilePosition(x), 2) <> "  " Then 
   If Day(Now) = CInt(Mid(CurrentDays2, FilePosition(x), 2)) Then
     Today1 = Blank
     Today2 = Mid(Blank, 1, FilePosition(x)) & "(  )" & Mid(Blank, FilePosition(x)+3, 168)
   End If
 End If
Next

FSO.CreateTextFile(Today1File, 1).Write(Today1)
FSO.CreateTextFile(Today2File, 1).Write(Today2)
End Function

'===================================================================================================================================

Private Function CreateReminder()
 SquareClickedOn = Mid(CurrentDays1, FilePosition(CP)+1, 1)
 If SquareClickedOn = " " Then SquareClickedOn = Mid(CurrentDays2, FilePosition(CP), 2)
 CurrentDayFile = CurrentMonthPath & SquareClickedOn & ".txt"
 If SquareClickedOn = "" Then CurrentDayFile = CurrentMonthPath & "0.txt"	'reminder for the entire month

 If FSO.FileExists(CurrentDayFile) Then   'retrieve reminders for the day
	ExistingMessages = FSO.OpenTextFile(CurrentDayFile, 1).Readline
	bCount = 0
	For y = 1 To len(ExistingMessages)
	 If Mid(ExistingMessages, y, 2) = "%b" Then 
	  bCount = bCount + 1
	  Separator(bCount)=y
	 End If
	Next
	For z = 1 To bCount - 1
	  ReminderMsg = ReminderMsg & "  " & z & " " & Hyphen & " " & Mid(ExistingMessages, Separator(z)+2, Separator(z+1)-Separator(z)-2) & Chr(13)
	Next
 End If

If SquareClickedOn <> "  " Then
 If CP = 99 Then	'enter a reminder for the entire month
  If ReminderMsg <> "" Then 
    Reminder = InputBox("Current Reminders:" & Chr(13) & ReminderMsg & Chr(13)&Chr(13)&Chr(13)&Chr(13)&Chr(13) & "Type " & Chr(34) & DelCommand & " #" & Chr(34) & " or " & Chr(34) & DelCommand & " ALL" & Chr(34) & " to delete reminders," & Chr(13) & "Or enter another reminder for " & ThisMonth & " and click OK:", ThisMonth & " " & ThisYear)
  Else 
    Reminder = InputBox(Chr(13)&Chr(13)&Chr(13)&Chr(13)&Chr(13) & "Enter a reminder for " & ThisMonth & " and click OK:", ThisMonth & " " & ThisYear)
  End If
 Else			'enter a daily reminder
  If ReminderMsg <> "" Then 
    Reminder = InputBox("Current Reminders:" & Chr(13) & ReminderMsg & Chr(13)&Chr(13)&Chr(13)&Chr(13)&Chr(13) & "Type " & Chr(34) & DelCommand & " #" & Chr(34) & " or " & Chr(34) & DelCommand & " ALL" & Chr(34) & " to delete reminders," & Chr(13) & "Or enter another reminder and click OK:", ThisMonth & " " & SquareClickedOn & ", " & ThisYear)
  Else 
    Reminder = InputBox(Chr(13)&Chr(13)&Chr(13)&Chr(13)&Chr(13) & "Enter a reminder and click OK:", ThisMonth & " " & SquareClickedOn & ", " & ThisYear)
  End If
 End If

	If Reminder <> "" Then 			'if something was entered
	  If Mid(Reminder, 1, Len(DelCommand)) = DelCommand Then	'delete a reminder
		If Mid(Reminder, Len(DelCommand)+2, 3) = "ALL" Then
		  Reminder = "%b"
		Else
		  MsgNumber = CInt(Mid(Reminder, Len(DelCommand)+2, 2)) + 1
		  EditedMessages = Mid(ExistingMessages, 1, Separator(MsgNumber-1)+1) & Mid(ExistingMessages, Separator(MsgNumber)+2, Len(ExistingMessages)) 
		  Reminder = EditedMessages
		End If	  
	    If Reminder = "%b" Then
	  	If Len(SquareClickedOn) = 2 Then		
		  CurrentReminders2 = Mid(CurrentReminders2, 1, FilePosition(CP)-1) & "  " & Mid(CurrentReminders2, FilePosition(CP)+2, 168-FilePosition(CP))
		Elseif Len(SquareClickedOn) = 1 Then 
		  CurrentReminders1 = Mid(CurrentReminders1, 1, FilePosition(CP)) & " " & Mid(CurrentReminders1, FilePosition(CP)+2, 168-FilePosition(CP))
		Elseif Len(SquareClickedOn) = 0 Then
		  If FSO.FileExists(CurrentMonthPath & "0.txt") Then FSO.DeleteFile(CurrentMonthPath & "0.txt")
		End If
	    End If
	  Else						'add a reminder
	  If Len(SquareClickedOn) = 2 Then		
	    CurrentReminders2 = Mid(CurrentReminders2, 1, FilePosition(CP)-1) & SquareClickedOn & Mid(CurrentReminders2, FilePosition(CP)+2, 168-FilePosition(CP))
	  Elseif Len(SquareClickedOn) = 1 Then 
	    CurrentReminders1 = Mid(CurrentReminders1, 1, FilePosition(CP)) & SquareClickedOn & Mid(CurrentReminders1, FilePosition(CP)+2, 168-FilePosition(CP))
	  End If

	  If ExistingMessages <> "" Then
	    Reminder = ExistingMessages & Reminder & "%b"
	  Else
	    Reminder = "%b" & Reminder & "%b"
	  End If
	  End If

	  If FSO.FileExists(CurrentDayFile) = 0 Then FSO.CreateTextFile(CurrentDayFile, 1).Write("%b%b")
	  FSO.CreateTextFile(CurrentDayFile, 1).Write(Reminder)
	  FSO.CreateTextFile(Reminders1File, 1).Write(CurrentReminders1)
	  FSO.CreateTextFile(Reminders2File, 1).Write(CurrentReminders2)
	  FSO.CreateTextFile(CurrentReminders1File, 1).Write(CurrentReminders1)
	  FSO.CreateTextFile(CurrentReminders2File, 1).Write(CurrentReminders2)
	End If
End If

End Function

'===================================================================================================================================

Private Function ExtractReminders()
If ThisMonth <> MonthName(Month(Now)) Then LookAhead = 0	   'do not look ahead for reminders, unless viewing the current month
TempThisYear = ThisYear
TempThisMonth = ThisMonth

For m = 0 To LookAhead
ThisYear	= Year(DateSerial(TempThisYear,Month("2000/" & TempThisMonth & "/1")+m,1))
ThisMonth	= MonthName(Month(DateSerial(TempThisYear,Month("2000/" & TempThisMonth & "/1")+m,1)),0)
CurrentYearPath 		= Path & "\DatesToRemember\" & ThisYear & "\"
CurrentMonthPath 		= CurrentYearPath & ThisMonth & "\"
CurrentReminders1File 	= CurrentMonthPath & "Reminders1.txt"
CurrentReminders2File 	= CurrentMonthPath & "Reminders2.txt"

 If FSO.FolderExists(CurrentYearPath) Then
  If FSO.FolderExists(CurrentMonthPath) Then
    CurrentReminders1 		= FSO.OpenTextFile(CurrentReminders1File, 1).Readline
    CurrentReminders2 		= FSO.OpenTextFile(CurrentReminders2File, 1).Readline

    y=0: TotalReminders=0 : notyet=0
	For x = 1 To len(CurrentReminders1) - 1
	 If Mid(CurrentReminders1, x, 2) = "%b" Then x=x+2
	 If Mid(CurrentReminders1, x, 1) <> " " Then 
	   y=y+1
	   TotalReminders=TotalReminders+1
	   ReminderDate(y) = Mid(CurrentReminders1, x, 1)
	 End If
	Next
	For x = 1 To len(CurrentReminders2) - 1
	 If Mid(CurrentReminders2, x, 2) = "%b" Then x=x+2
	 If Mid(CurrentReminders2, x, 1) <> " " Then 
	   y=y+1
	   TotalReminders=TotalReminders+1
	   ReminderDate(y) = Mid(CurrentReminders2, x, 2)
	   x=x+2
	 End If
	Next
	For x = 1 To TotalReminders
' 	  this next line causes old months to NOT display reminders
	  If DateSerial(Year(Now),Month(Now),Day(Now)-1) < DateSerial(ThisYear,Month(ThisMonth & " 1, " & ThisYear),ReminderDate(x)) Then
		If FSO.FileExists(CurrentMonthPath & "0.txt") And notyet=0 Then	'extract month reminder
		  MonthReminder = FSO.OpenTextFile(CurrentMonthPath & "0.txt", 1).Readline
		  If Len(MonthReminder) > 2 Then ReminderMessages = ReminderMessages & ThisMonth & " " & Hyphen & " " & Mid(MonthReminder, 3, Len(MonthReminder))
		  notyet=1
		End If

		ExtractDayFile = CurrentMonthPath & ReminderDate(x) & ".txt"
		Message = FSO.OpenTextFile(ExtractDayFile, 1).Readline
		bCount = 0
		
		For y = 1 To len(Message)
		 If Mid(Message, y, 2) = "%b" Then 
		  bCount = bCount + 1
		  Separator(bCount)=y
		 End If
		Next

		For z = 1 To bCount - 1
	    	  If z > 1 And Indention Then	'additional reminders will be indented
	    	    ReminderMessages = ReminderMessages & Space(Indention) & Hyphen & " " & Mid(Message, Separator(z)+2, Separator(z+1)-Separator(z)-2) & "%b"
	  	  Else					'additional reminders WON'T be indented
		    If ReminderPrefix = 0 Then Prefix = mid(ThisMonth, 1, 3) & " " & ReminderDate(x)
		    If ReminderPrefix = 1 Then Prefix = ReminderDate(x) & " " & mid(ThisMonth, 1, 3)
	  	    If DateSerial(Year(Now),Month(Now),Day(Now)) = DateSerial(ThisYear,Month(ThisMonth & " 1, " & ThisYear),ReminderDate(x)) Then
			 If TodayPrefix <> "" Then Prefix = "Today "
			 If TodayPrefix = "" Then Prefix = "(" & Prefix & ") " 
		        ReminderMessages = ReminderMessages & Prefix & Hyphen & " " & Mid(Message, Separator(z)+2, Separator(z+1)-Separator(z)-2) & "%b"
 	 	    Else
		        ReminderMessages = ReminderMessages & Prefix & " " & Hyphen & " " & Mid(Message, Separator(z)+2, Separator(z+1)-Separator(z)-2) & "%b"
		    End If
		  End If
		Next
	  End If
	Next
   FSO.CreateTextFile(ReminderMessagesFile, 1).Write(ReminderMessages)
  End If
 End If
Next
End Function

'===================================================================================================================================

Private Function ChangeMonth(m)
 If m = 0 Then 
   ThisYear = Year(Now)
   LastMonth = MonthName(Month(Now)-1,1)
   ThisMonth = MonthName(Month(Now))
   NextMonth = MonthName(Month(Now)+1,1)
 Else
   ThisYear	= Year(           DateSerial(ThisYear,Month("2000/" & ThisMonth & "/1")+m,1))
   LastMonth	= MonthName(Month(DateSerial(ThisYear,Month("2000/" & LastMonth & "/1")+m,1)),1)
   ThisMonth	= MonthName(Month(DateSerial(ThisYear,Month("2000/" & ThisMonth & "/1")+m,1)))
   NextMonth	= MonthName(Month(DateSerial(ThisYear,Month("2000/" & NextMonth & "/1")+m,1)),1)
 End If
 
 FSO.CreateTextFile(ThisYearFile, 1).Write(ThisYear)
 FSO.CreateTextFile(LastMonthFile, 1).Write(LastMonth)
 FSO.CreateTextFile(ThisMonthFile, 1).Write(ThisMonth)
 FSO.CreateTextFile(NextMonthFile, 1).Write(NextMonth)
End Function

'===================================================================================================================================

Private Function FilePosition(x)
 FilePosition = (x*3-3)+3*(RowPosition(x))-1
End Function

Private Function RowPosition(x)
 RowPosition = x\7
 If x Mod 7 Then RowPosition = RowPosition + 1
End Function

'===================================================================================================================================