'LoopCal 0.7     2004-04-25     by wesaft
'
'For use with DatesToRemember 1.1 in Samurize (included)
'Use Samurize 0.85b or newer
'
'FEATURES:
'A looping calendar that list a user editable days forward and backwards from today
'Highlights today    with green
'Highlights saturday with blue
'Highlights sundays  with green
'Add your own hardcoded "Red Days"
'Weeklines and Weeknumbers
'(List the swedish Namsdagar(Name of the day) yes, thats what the funny words are on the right ;))
'(just remove the textfile in the config if you dont want it)
'(removed in this rel, just the current name of the day at the top.)
'Uses DatesToRemember storage for reminders, so you can switch between them if you like
'(yes, that uziqs really old version, I plan to make a new verion that uses his new SimpleEvent files.)
'
'INSTALL:
'Put the LoopCal dir in the skins folder, and the *.ini in config, *vbs in scripts
'On first run, klick on "today" at the top to create all the files
'If the Calendar doesnt display the numbers or something else,
'just wait a sec and click refresh (klick the bottom left part)
'Dont flood the script with dubbelclicks
'klick the top left to quickly get to today, if you scrolled a loong time ahead.
'
'
'TODO:
'more example configs
'2 row version for each day, or only for next 5 days
'a whole month at a time.
'Flagdays
'Moon status
'use uziq simpelEvent rememinders
'
'HELP!
'Anyone knows how to calculate the reddays in sweden? (and flag days and moon status)
'
'Thanks to uziq for the DatesToRemember, thats what gave me the idea
'(and the nice write reminder functions :)
'
'/wesaft
'
'
'== USER EDITABLE VARIABLES ==========================================================================================================
DaysBefore		= 2	' Number of days to display before today (yes, I always forget to o stuff ;)
DaysAfter		= 8	' Days After Today
WeekDayNameLen	= 3	' 2=mo 3=mon 10=monday

NumOfRedDays = 3	'how many you entered below
Dim RedDays(3) 
RedDays(0) = DateSerial("2003","12","25")
RedDays(1) = DateSerial("2004","12","25")
RedDays(2) = DateSerial("2005","12","25")

'=====================================================================================================================================
'== DON'T EDIT BEYOND THIS POINT =====================================================================================================




aDate = Date
aDate = DateAdd("D", -DaysBefore , aDate)
aDay = Day(aDate)
aWeekDay = WeekDay(aDate)
aMonth = Month(aDate)
aMonthName = MonthName(aMonth)
aYear = Year(aDate)

Private Function AddDecDay(p)
	aDate = DateAdd("D", p , aDate)
	aDay = Day(aDate)
	aWeekDay = WeekDay(aDate)
	aMonth = Month(aDate)
	aMonthName = MonthName(aMonth)
	aYear = Year(aDate)
End Function

'============
' Offset Start
'============
Par = int(Wscript.arguments.Item(0))	'get offset parameter

Set FSO = CreateObject("Scripting.FileSystemObject")
SamurizeDir = CreateObject("WScript.Shell").RegRead("HKEY_CURRENT_USER\Software\Serious Samurize\General\DirPath")
Path 		= SamurizeDir & "Scripts"
Root			= Path & "\DatesToRemember\"
OffsetFile		= Root & "LoopCalOffset.txt"
Offset			= int(0)

'check folder
If FSO.FolderExists(Path & "\DatesToRemember") 	= 0 Then
	FSO.CreateFolder(Path & "\DatesToRemember")
End If

'read in offset
If FSO.FileExists(OffsetFile) Then
	Offset = int(FSO.OpenTextFile(OffsetFile, 1).Readline)
End If

If Par = -1 Then 'reset
	Offset = 0
ElseIf Par = -2 Then	'scroll back
	Offset = Offset - DaysBefore - DaysAfter
	'For i=0 to Abs(Offset)
		AddDecDay(Offset)
	'Next
ElseIf Par = -3 Then	'scroll forward
	Offset = Offset + DaysBefore + DaysAfter
	'For i=0 to Offset
		AddDecDay(Offset)
	'Next
ElseIf Par = -4 Then	'refresh
		AddDecDay(Offset)
End If

'check file
If FSO.FileExists(OffsetFile) = 0 Then
	FSO.CreateTextFile(OffsetFile, 1).Write(int(0))
End If

'write to OffsetFile
FSO.CreateTextFile(OffsetFile, 1).Write(Offset)
'msgbox("adate: " & aDate & "off: " & Offset)
'============
' Offset End 
'============





'============
' Create Reminder Start 
'============

'calculate CP value and run DTR
If (Par >= 0) Then
	'msgbox("Par=" & Par & " Offset= " & Offset)
	'msgbox("aDate before " & aDate)
	AddDecDay(Offset + Par)

	'msgbox("mont to add in: " & aMonthName)
	DateString = aMonthName & "/1/" & aYear
	FirstDayOfMonth = DatePart("w", DateString, 0)
	
	CP = aDay + FirstDayOfMonth -1
	'msgbox("first day of month " & FirstDayOfMonth & "cp= " & CP)

	'set the month in DTR
	ThisYearFile		= Root & "DatesToRememberThisYear.txt"
	LastMonthFile		= Root & "DatesToRememberLastMonth.txt"
	ThisMonthFile		= Root & "DatesToRememberThisMonth.txt"
	NextMonthFile		= Root & "DatesToRememberNextMonth.txt"

	lM = MonthName(Month(aDate)-1, 1)
	nM = MonthName(Month(aDate)+1, 1)

	FSO.CreateTextFile(ThisYearFile, 1).Write(aYear)
	FSO.CreateTextFile(LastMonthFile, 1).Write(lM)
	FSO.CreateTextFile(ThisMonthFile, 1).Write(aMonthName)
	FSO.CreateTextFile(NextMonthFile, 1).Write(nM)

	CreateObject("WScript.Shell").Run ".\Scripts\DatesToRemember.vbs " & CP,1,True

	'reset date
	AddDecDay(-Par)
End If

'============
' Create Reminder End
'============






'============
' DayNumber, WDName, Reminder, Namsdag Start
'============
DayNumberFile = Root & "LoopCalDayNumber.txt"
DayNumberRedFile = Root & "LoopCalDayNumberRed.txt"
DayNumberBlueFile = Root & "LoopCalDayNumberBlue.txt"
DayNameFile = Root & "LoopCalDayName.txt"
DayNameRedFile = Root & "LoopCalDayNameRed.txt"
DayNameBlueFile = Root & "LoopCalDayNameBlue.txt"
NameOfTheDayFile = Root & "LoopCalNameOfTheDay.txt"
RemindersFile = Root & "LoopcalReminders.txt"
WeekNumberFile = Root & "LoopcalWeekNumber.txt"
HighlightTodayFile = Root & "LoopCalHighlightToday.txt"
HighLightSundayFile = Root & "LoopCalHighlightSunday.txt"
HighLightSaturdayFile = Root & "LoopCalHighlightSaturday.txt"
WeekLineFile = Root & "LoopCalWeekLine.txt"
VerticalMonthNameFile = Root & "LoopCalVerticalMonthName.txt"

For i=0 To (DaysBefore + DaysAfter)
	
	Today = false
	RedDay = false

	If aDate = Date Then
		Today = true
		HighlightToday = HighlightToday & "%b"
	Else
		HighlightToday = HighlightToday & "%b"
	End If

	For j=0 To (NumOfRedDays-1)
		If RedDays(j) = DateSerial(aYear, aMonth, aDay) Then
			RedDay = true
		End If
	Next


	If aWeekday = 1 Or RedDay Then
		DayNumberRed = DayNumberRed & aDay & "%b"
		DayNumberBlue = DayNumberBlue & "%b"
		DayNumber = DayNumber & "%b"

		DayNameRed = DayNameRed & Left(WeekDayName(WeekDay(aDate)), WeekDayNameLen) & "%b"
		DayNameBlue = DayNameBlue & "%b"
		DayName = DayName & "%b"

		If Today Then
			HighlightSunday = HighlightSunday & "%b"
		Else
			HighlightSunday = HighlightSunday & "%b"
		End If

		HighlightSaturDay = HighlightSaturday & "%b"

	ElseIf aWeekday = 7 Then
		DayNumberRed = DayNumberRed & "%b"
		DayNumberBlue = DayNumberBlue & aDay & "%b"
		DayNumber = DayNumber & "%b"
		
		DayNameRed = DayNameRed & "%b"
		DayNameBlue = DayNameBlue & Left(WeekDayName(WeekDay(aDate)), WeekDayNameLen) & "%b"
		DayName = DayName & "%b"

		HighlightSunday = HighlightSunday & "%b"

		If Today Then
			HighlightSaturDay = HighlightSaturDay & "%b"
		Else
			HighlightSaturDay = HighlightSaturDay & "%b"
		End If

	Else
		DayNumberRed = DayNumberRed & "%b"
		DayNumberBlue = DayNumberBlue & "%b"
		DayNumber = DayNumber & aDay & "%b"

		DayNameRed = DayNameRed & "%b"
		DayNameBlue = DayNameBlue & "%b"
		DayName = DayName & Left(WeekDayName(WeekDay(aDate)), WeekDayNameLen) & "%b"

		HighlightSunday = HighlightSunday & "%b"
		HighlightSaturDay = HighlightSaturday & "%b"
	End If

	NameOfTheDay = NameOfTheDay & "%b" & Namsdag()
	
	If FSO.FileExists(Root & Year(aDate) & "\" & MonthName(Month(aDate)) & "\" & Day(aDate) & ".txt") Then 
		tmp = FSO.OpenTextFile(Root & Year(aDate) & "\" & aMonthName & "\" & Day(aDate) & ".txt").Readline
		tmp = Replace(tmp, "%b", " ")
		tmp = Trim(tmp)
		'msgbox("|" & tmp & "|")
		Reminders = Reminders & tmp & "%b"
	Else
		Reminders = Reminders & "%b"	
	End If
	
	If i = 0 Then
		WeekNumber = WeekNumber & DatePart("ww", DateSerial(aYear, Month(DateSerial(aYear,Month("2000/" & aMonthName & "/1"),1)), aDay-1), 1) & "%b"
	ElseIf aWeekDay = 2 Then
		WeekNumber = WeekNumber & DatePart("ww", DateSerial(aYear, Month(DateSerial(aYear,Month("2000/" & aMonthName & "/1"),1)), aDay), 1) & "%b"
		WeekLine = WeekLine & "______________________________________________________%b"
	Else
		WeekNumber = Weeknumber & "%b"
		WeekLine = WeekLine & "%b"
	End If

	If (i=0 And aDay<28) Or (aDay=1) Then
		stry = MonthName(Month(aDate))
		stry = Left(stry, 3)
		VerticalMonthName = VerticalMonthName & Left(stry, 1) & "%b" & Left(Right(stry, 2), 1) & "%b" & Right(stry, 1) & "%b" 'insert?
	Else
		VerticalMonthName = VerticalMonthName & "%b"
	End If
	
	'If aDay = 1 And i > 6
		
	AddDecDay(1)
Next

'MsgBox("aDate" & aDate)

'check folder
If FSO.FolderExists(Path & "\DatesToRemember") 	= 0 Then
	FSO.CreateFolder(Path & "\DatesToRemember")
End If

'write to file
FSO.CreateTextFile(DayNumberFile, 1).Write(DayNumber)
FSO.CreateTextFile(DayNumberRedFile, 1).Write(DayNumberRed)
FSO.CreateTextFile(DayNumberBlueFile, 1).Write(DayNumberBlue)
FSO.CreateTextFile(DayNameFile, 1).Write(DayName)
FSO.CreateTextFile(DayNameRedFile, 1).Write(DayNameRed)
FSO.CreateTextFile(DayNameBlueFile, 1).Write(DayNameBlue)
FSO.CreateTextFile(NameOfTheDayFile, 1).Write(NameOfTheDay)
FSO.CreateTextFile(RemindersFile, 1).Write(Reminders)
FSO.CreateTextFile(WeekNumberFile, 1).Write(WeekNumber)
FSO.CreateTextFile(HighlightTodayFile, 1).Write(HighlightToday)
FSO.CreateTextFile(HighlightSundayFile, 1).Write(HighlightSunDay)
FSO.CreateTextFile(HighlightSaturdayFile, 1).Write(HighlightSaturDay)
FSO.CreateTextFile(WeekLineFile, 1).Write(WeekLine)
FSO.CreateTextFile(VerticalMonthNameFile, 1).Write(VerticalMonthName)

'============
' DayNumber, WDName, Reminder, Namsdag Start
'============




'CreateReminder(Arg)

'CreateReminders(Arg)

Private Function CreateReminders(p)
	'aDate = Date(Date)
	aDay = Day(Now + p)
	aMonthName = MonthName(Month(Now +p))
	aYear = Year(Now + p)
	
	CurrentDayFile = Root & aYear & "\" & aMonthName & "\" & aDay & ".txt"

	RemindersFile = Root & "SamCalReminders.txt"
 
 If FSO.FileExists(CurrentDayFile) Then   'display reminders
	ExistingMessages = FSO.OpenTextFile(CurrentDayFile, 1).Readline
	ExistingMessages = Replace(ExistingMessages, "%b", " ")
	ExistingMessages = Trim(ExistingMessages)
 End If

 'write to disk
 If FSO.FileExists(RemindersFile) = 0 Then FSO.CreateTextFile(RemindersFile, 1).Write("%b%b")
    FSO.CreateTextFile(RemindersFile, 1).Write(ExistingMessages)
 'End If

End Function


Private Function GetWeekNumberIfNewWeek()
	
	MondayStart = 1	'MondayStart = 1 makes the weeks start on Monday
	
	ThisYear = aYear
	ThisMonth = aMonthName
	ThisDay = aDay
	DateString = DateSerial(ThisYear, Month(DateSerial(ThisYear,Month(ThisMonth & " 1, " & ThisYear),1)), ThisDay)

	FirstDayOfMonth = DatePart("w", DateString)					'start the week on Sunday
	If MondayStart Then FirstDayOfMonth = DatePart("w", DateString) - 1	'start the week on Monday

	If FirstDayOfMonth = 1 Then 
		Today           = Now() + p
		Year_           = Year(Today)
		GetWeekNumberIfNewWeek = DateDiff("ww", Year_&"-01-01",Today,0,0)+1
	Else
		GetWeekNumberIfNewWeek = ""
	End If

End Function



Private Function IsNewWeek(p)
	
	MondayStart = 1	'MondayStart = 1 makes the weeks start on Monday
	
	ThisYear = Year(Now + p) 
	ThisMonth = Month(Now + p)
	ThisDay = Day(Now + p)
	DateString = DateSerial(ThisYear, Month(DateSerial(ThisYear,Month(ThisMonth & " 1, " & ThisYear),1)), ThisDay)

	FirstDayOfMonth = DatePart("w", DateString)					'start the week on Sunday
	If MondayStart Then FirstDayOfMonth = DatePart("w", DateString) - 1	'start the week on Monday

	If FirstDayOfMonth = 1 Then 
		IsNewWeek = ""
	Else
		IsNewWeek = ""
	End If

End Function



'8888888888888888888888888888888888888888888888
'88                                          88
'88  Alla namsdagar plus en extra (Sam).     88
'88  De jvlarna (Svenska akademin),         88
'88  tog bort Sam frn den 1:a september :(  88
'88  Finns med i min version :)              88
'88                                          88
'88  Jag har copyright p detta s           88
'88  ni fr inte ta bort Sam ;)              88
'88                             /Sam         88
'88                                          88
'8888888888888888888888888888888888888888888888
Function Namsdag()
	dim manad, dag
	manad = Month(aDate)
	dag = Day(aDate)
	
	if manad = 1 then
    dim jan(30)
    jan(0) = "Nyrsdagen"
    jan(1) = "Svea"
    jan(2) = "Alfred, Alfrida"
    jan(3) = "Rut"
    jan(4) = "Hanna, Hannele"
    jan(5) = "Kasper, Melker, Baltsar"
    jan(6) = "August, Augusta"
    jan(7) = "Erland"
    jan(8) = "Gunnar, Gunder"
    jan(9) = "Sigurd, Sigbritt"
    jan(10) = "Jan, Jannike"
    jan(11) = "Frideborg, Fridolf"
    jan(12) = "Knut"
    jan(13) = "Felix, Felicia"
    jan(14) = "Laura, Lorentz"
    jan(15) = "Hjalmar, Helmer"
    jan(16) = "Anton, Tony"
    jan(17) = "Hilda, Hildur"
    jan(18) = "Henrik"
    jan(19) = "Fabian, Sebastian"
    jan(20) = "Agnes, Agneta"
    jan(21) = "Vincent, Viktor"
    jan(22) = "Frej, Freja"
    jan(23) = "Erika"
    jan(24) = "Paul, Pl"
    jan(25) = "Bodil, Boel"
    jan(26) = "Gte, Gta"
    jan(27) = "Karl, Karla"
    jan(28) = "Diana"
    jan(29) = "Gunilla, Gunhild"
    jan(30) = "Ivar, Joar"
    Namsdag = jan(dag-1)
  end if
  if manad = 2 then
    dim feb(28)
    feb(0) = "Max, Maximilian"
    feb(1) = "Kyndelsmssodagen"
    feb(2) = "Disa, Hjrdis"
    feb(3) = "Ansgar, Anselm"
    feb(4) = "Agata, Agda"
    feb(5) = "Dorotea, Doris"
    feb(6) = "Rikard, Dick"
    feb(7) = "Berta, Bert"
    feb(8) = "Fanny, Franciska"
    feb(9) = "Iris"
    feb(10) = "Yngve, Inge"
    feb(11) = "Evelina, Evy"
    feb(12) = "Agne, Ove"
    feb(13) = "Valentin"
    feb(14) = "Sigfrid"
    feb(15) = "Julia, Julius"
    feb(16) = "Alexandra, Sandra"
    feb(17) = "Frida, Fritiof"
    feb(18) = "Gabriella, Ella"
    feb(19) = "Vivianne"
    feb(20) = "Hilding"
    feb(21) = "Pia"
    feb(22) = "Torsten, Torun"
    feb(23) = "Mattias, Mats"
    feb(24) = "Sigvard, Sivert"
    feb(25) = "Torgny, Torkel"
    feb(26) = "Lage"
    feb(27) = "Maria"
    feb(28) = "Skottdagen"
    Namsdag = feb(dag-1)
  end if
  if manad = 3 then
    dim mar(30)
    mar(0) = "Albin, Elvira"
    mar(1) = "Ernst, Erna"
    mar(2) = "Gunborg, Gunvor"
    mar(3) = "Adrian, Adriana"
    mar(4) = "Tora, Tove"
    mar(5) = "Ebba, Ebbe"
    mar(6) = "Camilla"
    mar(7) = "Siv"
    mar(8) = "Torbjrn, Torleif"
    mar(9) = "Edla, Ada"
    mar(10) = "Edvin, Egon"
    mar(11) = "Viktoria"
    mar(12) = "Greger"
    mar(13) = "Matilda, Maud"
    mar(14) = "Kristoffer, Christel"
    mar(15) = "Herbert, Gilbert"
    mar(16) = "Gertrud"
    mar(17) = "Edvard, Edmund"
    mar(18) = "Josef, Josefina"
    mar(19) = "Joakim, Kim"
    mar(20) = "Bengt"
    mar(21) = "Kennet, Kent"
    mar(22) = "Gerda, Gerd"
    mar(23) = "Gabriel, Rafael"
    mar(24) = "Marie bebdelsedag"
    mar(25) = "Emanuel"
    mar(26) = "Rudolf, Ralf"
    mar(27) = "Malkolm, Morgan"
    mar(28) = "Jonas Jens"
    mar(29) = "Holger Holmfrid"
    mar(30) = "Ester"
    Namsdag = mar(dag-1)
  end if
  if manad = 4 then
    dim apr(29)
    apr(0) = "Harald, Hervor"
    apr(1) = "Gudmund, Ingeund"
    apr(2) = "Ferdinand, Nanna"
    apr(3) = "Marianne, Marlene"
    apr(4) = "Irene, Irja"
    apr(5) = "Vilhelm, Helmi"
    apr(6) = "Irma, Irmelin"
    apr(7) = "Nadja, Tanja"
    apr(8) = "Otto, Ottilia"
    apr(9) = "Ingvar, Ingvor"
    apr(10) = "Ulf, Ylva"
    apr(11) = "Liv"
    apr(12) = "Artur, Douglas"
    apr(13) = "Tiburtius"
    apr(14) = "Olivia, Oliver"
    apr(15) = "Patrik, Patricia"
    apr(16) = "Elias, Elis"
    apr(17) = "Valdemar, Volmar"
    apr(18) = "Olaus, Ola"
    apr(19) = "Amalia, Amelie"
    apr(20) = "Anneli, Annika"
    apr(21) = "Allan, Glenn"
    apr(22) = "Georg, Gran"
    apr(23) = "Vega"
    apr(24) = "Markus"
    apr(25) = "Teresia, Terese"
    apr(26) = "Engelbrekt"
    apr(27) = "Ture, Tyra"
    apr(28) = "Tyko"
    apr(29) = "Mariana"
    Namsdag = apr(dag-1)
  end if
  if manad = 5 then
    dim maj(30)
    maj(0) = "Valborg"
    maj(1) = "Filip, Filippa"
    maj(2) = "John, Jane"
    maj(3) = "Monika, Mona"
    maj(4) = "Gotthard, Erhard"
    maj(5) = "Marit, Rita"
    maj(6) = "Carina, Carita"
    maj(7) = "ke"
    maj(8) = "Reidar, Reidun"
    maj(9) = "Esbjrn, Styrbjrn"
    maj(10) = "Mrta, Mrit"
    maj(11) = "Charlotta, Lotta"
    maj(12) = "Linnea, Linn"
    maj(13) = "Halvard, Halvar"
    maj(14) = "Sofia, Sonja"
    maj(15) = "Ronald, Ronny"
    maj(16) = "Rebecka, Ruben"
    maj(17) = "Erik"
    maj(18) = "Maj, Majken"
    maj(19) = "Karolina, Carola"
    maj(20) = "Konstantin, Conny"
    maj(21) = "Hemming, Henning"
    maj(22) = "Desideria, Desiree"
    maj(23) = "Ivan, Vanja"
    maj(24) = "Urban"
    maj(25) = "Vilhelmina, Vilma"
    maj(26) = "Beda, Blenda"
    maj(27) = "Ingeborg, Borghild"
    maj(28) = "Yvonne, Jeanette"
    maj(29) = "Vera, Veronika"
    maj(30) = "Petronella, Pernilla"
    Namsdag = maj(dag-1)
  end if
  if manad = 6 then
    dim jun(29)
    jun(0) = "Gun, Gunnel"
    jun(1) = "Rutger, Roger"
    jun(2) = "Ingemar, Gudmar"
    jun(3) = "Solbritt, Solveig"
    jun(4) = "Bo"
    jun(5) = "Gustav, Gsta"
    jun(6) = "Robert, Robin"
    jun(7) = "Eivor, Majvor"
    jun(8) = "Brje, Birger"
    jun(9) = "Svante, Boris"
    jun(10) = "Bertil, Berthold"
    jun(11) = "Eskil"
    jun(12) = "Aina, Aino"
    jun(13) = "Hkan, Hakon"
    jun(14) = "Margit, Margot"
    jun(15) = "Axel, Axelina"
    jun(16) = "Torborg, Torvald"
    jun(17) = "Bjrn, Bjarne"
    jun(18) = "Germund, Grel"
    jun(19) = "Linda"
    jun(20) = "Alf, Alvar"
    jun(21) = "Paulina, Paula"
    jun(22) = "Adolf, Alice"
    jun(23) = "Johannes Dparens dag"
    jun(24) = "David, Salomon"
    jun(25) = "Rakel, Lea"
    jun(26) = "Selma, Fingal"
    jun(27) = "Leo"
    jun(28) = "Peter, Petra"
    jun(29) = "Elof, Leif"
    Namsdag = jun(dag-1)
  end if
  if manad = 7 then
    dim jul(30)
    jul(0) = "Aron, Mirjam"
    jul(1) = "Rosa, Rosita"
    jul(2) = "Aurora"
    jul(3) = "Ulrika, Ulla"
    jul(4) = "Laila, Ritva"
    jul(5) = "Esaias, Jessika"
    jul(6) = "Klas"
    jul(7) = "Kjell"
    jul(8) = "Jrgen, rjan"
    jul(9) = "Andre, Andrea"
    jul(10) = "Eleonora, Ellinor"
    jul(11) = "Herman, Hermine"
    jul(12) = "Joel, Judit"
    jul(13) = "Folke"
    jul(14) = "Ragnhild, Ragnvald"
    jul(15) = "Reinhold, Reine"
    jul(16) = "Bruno"
    jul(17) = "Fredrik, Fritz"
    jul(18) = "Sara"
    jul(19) = "Margareta, Greta"
    jul(20) = "Johanna"
    jul(21) = "Magdalena, Madeleine"
    jul(22) = "Emma"
    jul(23) = "Kristina, Kerstin"
    jul(24) = "Jakob"
    jul(25) = "Jesper"
    jul(26) = "Marta"
    jul(27) = "Botvid, Seved"
    jul(28) = "Olof"
    jul(29) = "Algot"
    jul(30) = "Helena, Elin"
    Namsdag = jul(dag-1)
  end if
  if manad = 8 then
    dim aug(30)
    aug(0) = "Per"
    aug(1) = "Karin, Kajsa"
    aug(2) = "Tage"
    aug(3) = "Arne, Arnold"
    aug(4) = "Ulrik, Alrik"
    aug(5) = "Alfons, Inez"
    aug(6) = "Dennis, Denise"
    aug(7) = "Silvia, Sylvia"
    aug(8) = "Roland"
    aug(9) = "Lars"
    aug(10) = "Susanna"
    aug(11) = "Klara"
    aug(12) = "Kaj"
    aug(13) = "Uno"
    aug(14) = "Stella, Estelle"
    aug(15) = "Brynolf"
    aug(16) = "Verner, Valter"
    aug(17) = "Ellen, Lena"
    aug(18) = "Magnus, Mns"
    aug(19) = "Bernhard, Bernt"
    aug(20) = "Jon, Jonna"
    aug(21) = "Henrietta, Henrika"
    aug(22) = "Signe, Signhild"
    aug(23) = "Bartolomeus"
    aug(24) = "Lovisa, Louise"
    aug(25) = "sten"
    aug(26) = "Rolf, Raoul"
    aug(27) = "Gurli, Leila"
    aug(28) = "Hans, Hampus"
    aug(29) = "Albert, Albertina"
    aug(30) = "Arvid, Vidar"
    Namsdag = aug(dag-1)
  end if
  if manad = 9 then
    dim sep(29)
    sep(0) = "Sam, Samuel, Samurize"
    sep(1) = "Justus, Justina"
    sep(2) = "Alfhild, Alva"
    sep(3) = "Gisela"
    sep(4) = "Adela, Heidi"
    sep(5) = "Lilian, Lilly"
    sep(6) = "Regina, Roy"
    sep(7) = "Alma, Hulda"
    sep(8) = "Anita, Annette"
    sep(9) = "Tord, Turid"
    sep(10) = "Dagny, Helny"
    sep(11) = "sa, slg"
    sep(12) = "Sture"
    sep(13) = "Ida"
    sep(14) = "Sigrid, Siri"
    sep(15) = "Dag, Daga"
    sep(16) = "Hildegard, Magnhild"
    sep(17) = "Orvar"
    sep(18) = "Fredrika"
    sep(19) = "Elise, Lisa"
    sep(20) = "Matteus"
    sep(21) = "Maurits, Moritz"
    sep(22) = "Tekla, Tea"
    sep(23) = "Gerhard, Gert"
    sep(24) = "Tryggve"
    sep(25) = "Enar, Einar"
    sep(26) = "Dagmar, Rigmor"
    sep(27) = "Lennart, Leonard"
    sep(28) = "Mikael, Mikaela"
    sep(29) = "Helge"
    Namsdag = sep(dag-1)
  end if
  if manad = 10 then
    dim okt(30)
    okt(0) = "Ragnar, Ragna"
    okt(1) = "Ludvig, Love"
    okt(2) = "Evald, Osvald"
    okt(3) = "Frans, Frank"
    okt(4) = "Bror"
    okt(5) = "Jenny, Jennifer"
    okt(6) = "Birgitta, Britta"
    okt(7) = "Nils"
    okt(8) = "Ingrid, Inger"
    okt(9) = "Harry, Harriet"
    okt(10) = "Erling, Jarl"
    okt(11) = "Valfrid, Manfred"
    okt(12) = "Berit, Birgit"
    okt(13) = "Stellan"
    okt(14) = "Hedvig, Hillevi"
    okt(15) = "Finn"
    okt(16) = "Antonia, Toini"
    okt(17) = "Lukas"
    okt(18) = "Tore, Tor"
    okt(19) = "Sibylla"
    okt(20) = "Ursula, Yrsa"
    okt(21) = "Marika, Marita"
    okt(22) = "Severin, Sren"
    okt(23) = "Evert, Eilert"
    okt(24) = "Inga, Ingalill"
    okt(25) = "Amanda, Rasmus"
    okt(26) = "Sabina"
    okt(27) = "Simon, Simone"
    okt(28) = "Viola"
    okt(29) = "Elsa, Isabella"
    okt(30) = "Edit, Edgar"
    Namsdag = okt(dag-1)
  end if
  if manad = 11 then
    dim nov(29)
    nov(0) = "Allhelgonadagen"
    nov(1) = "Tobias"
    nov(2) = "Hubert, Hugo"
    nov(3) = "Sverker"
    nov(4) = "Eugen, Eugenia"
    nov(5) = "Gustav, Adolf"
    nov(6) = "Ingegerd, Ingela"
    nov(7) = "Vendela"
    nov(8) = "Teodor, Teodora"
    nov(9) = "Martin Martina"
    nov(10) = "Mrten,"
    nov(11) = "Konrad, Kurt"
    nov(12) = "Kristian, Krister"
    nov(13) = "Emil, Emilia"
    nov(14) = "Leopold"
    nov(15) = "Vibeke, Viveka"
    nov(16) = "Naemi, Naima"
    nov(17) = "Lillemor, Moa"
    nov(18) = "Elisabet, Lisbet"
    nov(19) = "Pontus, Marina"
    nov(20) = "Helga, Olga"
    nov(21) = "Cecilia, Sissela"
    nov(22) = "Klemens"
    nov(23) = "Gudrun, Rune"
    nov(24) = "Katarina, Katja"
    nov(25) = "Linus"
    nov(26) = "Astrid, Asta"
    nov(27) = "Malte"
    nov(28) = "Sune"
    nov(29) = "Andreas, Anders"
    Namsdag = nov(dag-1)
  end if
  if manad = 12 then
    dim dec(30)
    dec(0) = "Oskar, Ossian"
    dec(1) = "Beata, Beatrice"
    dec(2) = "Lydia"
    dec(3) = "Barbara, Barbro"
    dec(4) = "Sven"
    dec(5) = "Nikolaus, Niklas"
    dec(6) = "Angela, Angelika"
    dec(7) = "Virginia"
    dec(8) = "Anna"
    dec(9) = "Malin, Malena"
    dec(10) = "Daniel, Daniela"
    dec(11) = "Alexander, Alexis"
    dec(12) = "Lucia"
    dec(13) = "Sten Sixten"
    dec(14) = "Gottfrid"
    dec(15) = "Assar"
    dec(16) = "Stig"
    dec(17) = "Abraham"
    dec(18) = "Isak"
    dec(19) = "Israel, Moses"
    dec(20) = "Tomas"
    dec(21) = "Natanael, Jonatan"
    dec(22) = "Adam"
    dec(23) = "Eva"
    dec(24) = "Juldagen"
    dec(25) = "Stefan, Staffan"
    dec(26) = "Johannes, Johan"
    dec(27) = "Benjamin / Vrnlsa barns dag"
    dec(28) = "Natalia, Natalie"
    dec(29) = "Abel, Set"
    dec(30) = "Sylvester"
    Namsdag = dec(dag-1)
  end if
End Function